/*
 * Author: Jake Goodwin
 * Filename: interface.h
 * Description: The file you should include for normal use.
 */

/*Function pointers for the TX and RX fuctionality*/

#ifndef _GY521_INTERFACE_H
#define _GY521_INTERFACE_H

#include "stdint.h"

/*
 * ############################
 * DEFINES 
 * ############################
 */ 

#define     STARTUP_DELAY 30 //in ms
#define     TWI_GY521_ADDR1 0x68    //ADO Logic Low
#define     TWI_GY521_ADDR2 0x69    //ADO Logic High

/*
 * ############################
 * Structures & Typedefs 
 * ############################
 */ 


typedef struct gy521_module gy521_module;

typedef enum{
    passed = 0,
    gyro_failed,
    accel_failed,
}self_test_results;


/*
 * ############################
 * Fuction Prototypes
 * ############################
 */ 

extern void (*gy521_twi_tx)(uint8_t, uint8_t*, uint8_t);
extern void (*gy521_twi_rx)(uint8_t, uint8_t*, uint8_t);


struct gy521_module* gy521_new(void);
_Bool gy521_init(struct gy521_module *m, uint8_t slave_address);
void gy521_update_gyro(struct gy521_module* m);
void gy521_update_accel(struct gy521_module* m);
void gy521_free(struct gy521_module *m);

#endif
